// Pom1 Apple 1 Emulator
// Copyright (C) 2000 Verhille Arnaud
// Copyright (C) 2012 John D. Corrado
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
#include "n2DLib.h"
#include <stdio.h>
#include <os.h>
#include <stdlib.h>
#include <string.h>
#include "memory.h"
#include "keyboard.h"
#include "screen.h"
#include "config.h"

#define TYPE_STRING 1
#define TYPE_DECIMAL 2
#define TYPE_HEXADECIMAL 3
#define TYPE_CHOICE 4

#define isHexDigit(c) ((c >= '0' && c <= '9') || ((c & 0x5F) >= 'A' && (c & 0x5F) <= 'F'))

static int step, type, max, choice;
static unsigned int start;
static char buffer[1024];
static FILE *fp;

#define filename "memory.tns"

static void drawString(const char *str, int x, int y)
{
	char c;
	const char *p = str;
	int X = x;
	int characterWidth = 7 * getPixelSize(), characterHeight = 8 * getPixelSize();

	while (c = *p++)
	{
		if (c == '\n')
		{
			X = x;
			y += characterHeight;
		}
		else
		{
			drawCharacter(X, y, 0, 0, 0, c);
			X += characterWidth;
		}
	}
}

static int changeTerminalSpeedFunc(void)
{
	int terminalSpeed = atoi(buffer);

	if (terminalSpeed < 1 || terminalSpeed > 120)
		fprintf(stderr, "stderr: Terminal speed out of range\n");
	else
	{
		setTerminalSpeed(terminalSpeed);
		printf("stdout: terminalSpeed=%d\n", getTerminalSpeed());
	}

	return 0;
}

static int setIrqBrkVectorFunc(void)
{
	unsigned int brkVector;

	sscanf(buffer, "%4X", &brkVector);
	memWrite(0xFFFE, (unsigned char)brkVector);
	memWrite(0xFFFF, (unsigned char)(brkVector >> 8));
	printf("stdout: brkVector=%s\n", buffer);

	return 0;
}
